import React from "react";
import ReactDOM from "react-dom";
import Observable from "./Observable";
import Watch from "./Watch";
import Component from "./Component";
export * from "./Component";
export default function Vue(options) {
    const RootComponent = Component(options);
    const props = {
        ...options.propsData,
        $el: options.el,
    };
    return ReactDOM.render(React.createElement(RootComponent, props), options.el);
}
Vue.component = Component;
Vue.observable = Observable;
Vue.watch = function (expFn, watchFn, scope = null) {
    const watcher = new Watch(scope, expFn, watchFn);
    return () => watcher.clearDeps();
};
